#!/usr/bin/perl -I .

use strict;
use Test::More;
use FDN::Common::Logger;

my $nbtest;

# /1
ok(1, "Capable de tester");
BEGIN{ $nbtest += 1; }

my $msg = "Mon message ";
my $n = 1;
logger_prefix('testing');

sub ma_fonction($$) {
	my ( $fct, $msg) = @_;
	return &$fct($msg);
}

my ($last, $line);
# /9
ok(ma_fonction(\&debug,$msg.$n), "debug"); $line = __LINE__;
is(get_last_debug_msg(), $msg.$n, "last debug");
$last = get_last_debug();
ok(ref $last eq 'HASH',  "last debug");
is( $last->{'msg'}, $msg.$n, "last debug");
is( $last->{'level'}, 'debug', "last debug");
ok( defined $last->{'time'} && $last->{'time'} > 0, "last debug");
is( $last->{'module'}, 'main', "last debug");
is( $last->{'line'}, $line, "last debug");
is( $last->{'file'}, __FILE__, "last debug");
is( $last->{'fct'}, 'main::ma_fonction', "last debug");
BEGIN{ $nbtest += 10; }

$n++;

# /3
ok(info($msg.$n), "info");
ok(get_last_info_msg() eq $msg.$n, "last info");
ok(ref get_last_info() eq 'HASH',  "last info");
BEGIN{ $nbtest += 3; }

$n++;

# /3
ok(notice($msg.$n), "notice");
ok(get_last_notice_msg() eq $msg.$n, "last notice");
ok(ref get_last_notice() eq 'HASH',  "last notice");
BEGIN{ $nbtest += 3; }

$n++;

# /3
ok(warning($msg.$n), "warning");
ok(get_last_warning_msg() eq $msg.$n, "last warning");
ok(ref get_last_warning() eq 'HASH',  "last warning");
BEGIN{ $nbtest += 3; }

$n++;

# /3
ok(error($msg.$n), "error");
ok(get_last_error_msg() eq $msg.$n, "last error");
ok(ref get_last_error() eq 'HASH',  "last error");
BEGIN{ $nbtest += 3; }

$n++;

# /3
ok(critic($msg.$n), "critic");
ok(get_last_critic_msg() eq $msg.$n, "last critic");
ok(ref get_last_critic() eq 'HASH',  "last critic");
BEGIN{ $nbtest += 3; }

$n++;

# /3
ok(alert($msg.$n), "alert");
ok(get_last_alert_msg() eq $msg.$n, "last alert");
ok(ref get_last_alert() eq 'HASH',  "last alert");
BEGIN{ $nbtest += 3; }


BEGIN { plan tests => $nbtest; }

